History

Game history

Where the game comes from:

I don't know where the game comes from.

What does Shisen-sho mean:

I have been said that the name means “Shisen state” from the name of a Chinese country.

Shisen-sho design:

I first see this game under Linux KDE desktop.(Created in 1997 by Mario Weilguni mweilguni@sime.com using the qt technology)

There are various Japanese Windows versions over the Internet.

This game is modeled after the KDE Kshisen game. This is not a port. The program has totally been re-written using .NET WPF framework .

I have also taken idea from other implementations.:

Sisen for Win32 by Ono Shinji (1998)

Shisen Sho for Java by Barry Neilsen (1999) barry@redsand.demon.co.uk

Some tile bitmaps have been built using part of the IBM Visualage Toolkit Mahjong sample.

Some tile sets have been built using the public domain collection maintained by Ron Balewski for his Mahjong (MJVGA and MJWIN)(Ron Balewski 412 E. Ridge St. Nanticoke, PA 18634-2915) ; for those tile sets I have built the 3D tile and copied the original picture.

Originally I wrote this program for me, to be able to play without booting Linux.

Development:

Microsoft Visual C# 2005 Express Edition is used to compile this program.

Program profile and scores:

These data are stored in a directory:

C:\Documents and Settings\User_Name\Local Settings\Application Data\TheSeaHorse\ShisenCS.exe_Url_idkttb4ign45k02ia1a22wznel4lec1a\4.3.4.0...

Figure 2 Registry data for Shisen-sho

OS/2 Version:

There is an OS/2 version available from my homepage.

Features:

This version of Shisen-sho has more features than any of the above. It is totally re-sizeable. I don't know if these features are related to any real Shisen-sho game. I am interested on any information.


Game keys

Keys

Shisen-sho available short-cuts are:

Available keys are:

  • Ctrl-A Get all hints (Cheat mode)

  • Ctrl-F Fall mode. (Set and reset fall mode)

  • Ctrl-G Gravity mode. (Set and reset gravity mode)

  • Ctrl-H Get a random hint and number of available hits

  • Ctrl-I Is game solvable ?

  • Ctrl-N get a new board

  • Ctrl-P Pause/Continue the game

  • Ctrl-R Redo last undo

  • Ctrl-S Restart from the beginning (same as repeated Ctrl-X)

  • Ctrl-C Restart from the beginning (same as repeated Ctrl-X) and clear undo/redo history and time counter.

  • Ctrl-T Attraction mode. (Set and reset fall mode)

  • Ctrl-X Undo

  • Alt-F4 Quit the game

  • Alt-F11 Best scores

  • Alt-F12 About

  • F1 Gets help (this can be sued after selecting any menu item.)

  • F10 selects menu

  • F11 Toggle switch between normal windowed view and full screen view

  • Space stops demo mode.

  • Pause key Pause/Continue the game

  • ESC restores Pause and full screen view

Disabled people

Disabled people can play Shisen-sho with one finger

Available keys are:

Numeric keypad directions (in numeric mode) (8 directions)

  • Character mode with 'e', 'r','t','d','g','c','v','b' for the 8 directions

  • tile selection with numeric keypad '5' in numeric mode, 'f',or enter.

  • hint with 'Ctrl-h' (Use Sticky Keys in Windows Accssibility options) or Shift

  • Insert or 'N' replace the mouse right button to show all tiles of same type

for one position.

  • all hints with 'Ctrl-a'

  • standard access to menus with 'Alt' then direction keys.

  • standard menu selection with the enter key.

Shisen-sho Mouse functions:

Left button click: select a new tile or the second tile of a link-able set. De-select current selected tile.

Right button click: show all tiles of a type.

Toolbar buttons:

The toolbar buttons duplicate some menu functions for direct access.


Language

Language switching:

Shisen-Sho has National Language support for those languages which have been translated.

When a Language exists, a DLL is available in the application directory for this language.

If multiple DLL exist, the “Language” menu shows the available languages.

You can switch from a language to another while playing.

The application momorize the last used language and start in this language.

This day, this program has been translated to:

  • German by Christian Hennecke

  • French by Daniel F Valot

  • Hungarian by Leonard Nimoy

  • Italian by Marco D›Amato

  • Norwegian by Vegard Krog Petersen

  • Russian by Iren Matsenko

  • Swedish by Jan-Erik Lärka

  • Uzbek by Sherzod Mamatkulov

Please, write to me only in English or French.


License information

License

<<Daniel F Valot Software>> The ARDI family software

License and Legal Information

  • Shisen-sho is refered to as the Shisen software hereafter.

  • This Shisen Software is owned by Daniel Valot

  • You are granted a nonexclusive license to use this Shisen Software solely for your own business purposes. The user shall not commercially distribute, sublicense, resell, or otherwise transfer for any consideration, or reproduce for any such purposes, the Shisen software or any modification or derivation thereof, either alone or in conjunction with any other product or program. Further, the user shall not modify the Shisen Software, other than for his own business use.

THE Shisen SOFTWARE IS PROVIDED TO THE USER "AS IS". THE AUTHOR MAKES NO WARRANTIES, EITHER EXPRESSED OR IMPLIED, WITH RESPECT TO THE Shisen SOFTWARE AND/OR ASSOCIATED MATERIALS PROVIDED TO THE USER, INCLUDING BUT NOT LIMITED TO ANY WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND AGAINST INFRINGEMENT.

==LIMITATION OF LIABILITY --THE AUTHOR SHALL NOT BE LIABLE FOR ANY CLAIMS OR DAMAGES WHATSOEVER, INCLUDING PROPERTY DAMAGE, PERSONAL INJURY, INTELLECTUAL PROPERTY INFRINGEMENT, LOSS OF PROFITS, OR INTERRUPTION OF BUSINESS, OR FOR ANY SPECIAL, CONSEQUENTIAL OR INCIDENTAL DAMAGES, HOWEVER CAUSED, WHETHER ARISING OUT OF BREACH OF WARRANTY, CONTRACT, TORT (INCLUDING NEGLIGENCE), STRICT LIABILITY, OR OTHERWISE.

==The Shisen software is not shareware nor freeware. You can only get it from me (Daniel F Valot) or my homepage. You do not have to pay anything for version 1.00 to 1.30

Shisen (c) Copyright Daniel F Valot 2000-2006


Add Tile sets

Managing Tile sets

Where are tile sets stored ?

There is one tile sets stored in the application to be able to play the game with only the application file when disk size need to be saved

Most of other tile sets are stored in a DLL placed in the application directory.

The Irina Allegrova fan club version has only one resident font and no DLL fonts.

Starting with version 1.14 you can design and use you own tile sets.

You can look at the few external tile sets provided with SHISEN-SHO.

How to design external tile sets ?

External tile sets are 8 bit (256 colors) bitmap files.

Tiles are placed in six rows of nine tiles.

Any tile has ONE pixel added on the left and bottom side.

Consider bitmaps provided with the game as sample. The bitmap size must not be too large. The WALTE256.BMP file provided is too large to work properly on most systems. I recommend using the TEMPLATE.BMP file to draw your own design over it.

How to add my own tile sets to the game ?

First place your bitmap in the SHISEN-SHO directory.

Go to the file menu and press “Manage tile sets”

In the Manage tile sets dialog press add to select your bitmap file.

Then edit the dialog to set a name for your tile set and put your name in the author name field.

Adjust the color for the tile set right side color.

You will be able to change this later if tests are not good.

Press OK to write your tile set data to the application tile set list (SHISENTS.LST)

How to delete unwanted tile set from the application tile set list ?

Go to the file menu and press “Manage tile sets”

Use next / previous button to select the desired bitmap and press “delete” to remove it from the list.

This will not remove the bitmap from the application directory.

How to change tile set side color ?

Go to the file menu and press “Manage tile sets”

Use next / previous button to select the desired bitmap and change Red, green blue component colors Then press OK to save the value.


Other options

Other available options are:

Some options are just for the fun:

  1. Speed, this is just a visual speed, you can play faster. Every selected pair of tiles starts a new thread which runs on its own.

  2. Animated link.

  3. Show high scores. You can remove unwanted scores.

There is a score board per board size. The score board shows the mode the game was run (Normal, Gravity; Fall or attraction mode) ; The title bar shows the game mode.


Playing Shisen-sho

Board setup :

The board is built differently according to:

1-The size and tile set

It can be selected as 14*6, 18*8, 24*12, 26*14 or 30*16. (with Setup->size)

Several tile sets are provided.

2-The difficulty level

It can be selected as “easy”,” medium” or “Hard”. There is no real difference between easy and medium. Hard suppresses most of double adjacent tiles.(with Setup->Level).

3-Solvable game:

When building the game, the program tries to solve the game with one of its internal solvers. I have not yet succeeded to write an acceptable solver. When the game tells you the game is solvable, it is solvable, but when it says it is not solvable, you can most of the times solve it. The only reliable solver I have written may take hours to solve the game recursively, so I avoid using it.

4-Gravity mode:

In this mode, tiles are shifted toward the board bottom. Undo and redo can still be used. The mode can only be set before playing.

5-Fall mode:

This combine gravity mode and tile falls. Tile column heights are compared with previous and next column. The biggest difference is used to select the falling tile. If there are several columns with the biggest difference, the one on the left is used.

6-Attraction mode:

In this mode, empty vertical or horizontal rows and columns are suppressed.

This make the game more difficult.

7-Suppress beep:

To work quietly.

8-Suppress 3D display:

For slow PC

9-Asama bitmap background:

To use if the display doesn›t flicker when using it. The Asama mount is a volcano near Tokyo.

10-Disabled people setup:

This setup allows game playing with one finger. (Without using the mouse) Read Keys section

11-Use default background:

This set the default background. You can load your own bitmaps with the “Files” drop down menu “Load background bitmap”. Only BMP, JPEG and PNG bitmaps are supported. Loading an unsupported bitmap can gives unpredictable results. Some Old OS/2 bitmaps can be loaded also.

Undo / redo facility

Any tile you remove is added to the undo list.

Any tile you add with the undo option is added to the redo list.

These options are only available when the lists are not empty.

Undo/Redo facility activates the cheat status, but as this usually take more time, this is not accounted for in the final result.

The Demo mode:

The Demo mode can be used make the game more difficult by starting with a partially solved game. You can stop the demo with the space key. When using the demo mode during a session, the Demo is written down on the high score board.

The Full screen view:

You can switch between normal windowed view and full screen mode with the F11 key (ESC or F11 to quit).


Problems

Known problems

Corrupted display:

On slow PC or Slow video card you may experience corrupted display. Resize the board to clear it

Fixes:

Program versions:

1.02 Fix problem with missing menu under Window 95

1.03 New dialogs and OS/2 version.

1.04 Fall mode and toolbar.

1.05 Attraction mode, Disabled people access, 3D display, Background bitmap, two tile sets.

1.06 Same features. OS/2 code rework to avoid problem with GRADD drivers. Code maintenance.

1.07 Same features. OS/2 code rework to avoid problem with GRADD drivers. Code maintenance.

1.08 Added 7 tile sets in a DLL file. The file must be in the same directory.

1.09 Add custom background bitmap

1.10 Suppress most of cheat facilities. Add restart with clear mode.

1.11 Fix 3D bug introduced in 1.10. Button bitmaps by Klaus Staedtler-Przyborski.

1.12-Fix problems with SDD drivers

1.13-Place OS/2 profile in application path (OS/2 version)

1.14-Add external tile sets.

1.15 Adjust toolbar position and size (Windows XP)

1.15 Create a version for Irina Allegrova fan club

1.16-Maintenance release.

1.17 Add national language support

1.20 Add full screen mode – re-write the program in UNICODE

1.30 New .Net framework version written in C# using Windows Presentation Fondation.


Application functions

Program purpose:

This is a solitary game.

To play Shisen-sho you have to remove all tiles two by two.

To be removable, the tiles must be connected by a “Link” having no more than three segments.

Figure 1 Connecting tiles

Playing Shisen-sho:

  1. The link segments cannot cross tiles

  2. You can select different board size with the Setup menu.

  3. Most of the time it is easier to solve larger boards than smaller boards.

  4. Best players are those solving the board in less time than others.

  5. To allow fair competition, most of the cheat tricks have been suppressed.


Saving boards

Board saving, loading, building

Building the board:

Before playing, a board must be built. Shisen-shotakes care of this by default for you.

But if the game presented to you doesn't suit you, you can ask for a new game (Ctrl-N).

Saving loading boards:

You can also save a party to disk and reload it later. Saving a game, saves the board, the list of played tiles and the list of un-played tiles. It also save the game setup.

After restoring a board, you can either start the game from the restoring point or restart the game from the beginning with or without clearing the undo/redo history and the time counter.


TheSeaHorse

Hippocampus or Sea Horse:

TheSeaHorse is the symbol and name of the program family. This is not a company name nor a registered name.

Figure 3 A real hippocampus I found in the sea when I was twelve. (size 5 cm)


Help index

Solitary game Shisen-sho for Windows

Application functions

Game history and technical data

Playing Shisen-sho

Saving boards

Mouse and keyboard

Other options

Managing Tile Sets

The Sea Horse symbol

Known problems

License

Language

Version 1.30

Copyrights Daniel F Valot October 24, 2006

Email:

http://dvalot.free.fr